#ifndef CHR_CHRONOS_H
#define CHR_CHRONOS_H

#include "chr_common.h"

#include "chr_table.h"
#include "chr_flash.h"
#include "chr_cursor.h"
#include "chr_flashgui.h"

#include <map>
#include <string>

struct chr_table_ctx
{
  size_t key_size;
  size_t value_size;
  chr_table * table;
  int open_count;
  chr_cursor * open_cursor(const unsigned char * key,
      chr_pos_type type = CHR_KEY);
  int close_cursor(chr_cursor * cursor);
};

class chr_chronos
{
public:
  chr_chronos(const char * device, const char * folder);
  ~chr_chronos();

  int create_table(const char * table_name, size_t key_size,
      size_t value_size);
  int drop_table(const char * table_name);
  chr_table_ctx * open_table(const char * table_name);
  int close_table(chr_table_ctx * ctx);

private:
  chr_chronos(const chr_chronos &);
  chr_chronos & operator=(const chr_chronos &);

  chr_flashgui * flashgui;
  chr_flash * flash;
  char * folder;
  std::map<std::string, chr_table_ctx*> tables;

};

#endif /* CHR_CHRONOS_H */

