#ifndef CHR_COMMON_H
#define CHR_COMMON_H

#define CHR_OK           0
#define CHR_ERR         -1
#define CHR_EOF         -2
#define CHR_UNKNOWN_POS -3
#define CHR_OOR        -30
#define CHR_FOUND       10
#define CHR_NOTFOUND   -31
#define CHR_DUPKEY     -32
#define CHR_READ_ERR   -40
#define CHR_WRITE_ERR  -41
#define CHR_NEXTLEAF   -50
#define CHR_PREVLEAF   -51

typedef unsigned long long chr_lsn;

enum chr_pos_type {CHR_KEY, CHR_FIRST, CHR_LAST};
enum chr_pos_where {CHR_BEFORE, CHR_AFTER, CHR_ON};

#define CHR_BLOCK_SIZE 4096
#define CHR_EPSILON 10
/* minimum threshold of | { free_sectors } | / | { all_sectors } | */
#define CHR_DEV_THRESHOLD 0.25
/* increment when threshold is reached */
#define CHR_DEV_SIZE_INCR 10

#define CHR_FILE "chronos.chr"
#define CHR_FLASH_FILE "device.chr"

#define CHR_NO_GUI

/* GUI settings */
#ifndef CHR_NO_GUI
#define CHR_FLASH_GUI chr_flashgui_text
#define CHR_BTREE_GUI chr_btreegui_latex
#else /* CHR_NO_GUI */
#define CHR_FLASH_GUI chr_flashgui
#define CHR_BTREE_GUI chr_btreegui
#endif /* CHR_NO_GUI */

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <sstream>

static inline void dbug_dumb(const unsigned char * value, size_t size)
{
  std::ostringstream ret;
  ret << std::hex;
  for(size_t i = 0; i < size; i++)
  {
    char tmp[3];
    sprintf(tmp, "%02X", (unsigned short)value[i]);
    ret << tmp;
  }
  std::cerr << ret.str() << std::endl;
}

#endif /* CHR_COMMON_H */

