#include "chr_flashgui_text.h"

#include <stdio.h>
#include <stdlib.h>

chr_flashgui_text::chr_flashgui_text()
{
  rd_count = 0;
  nw_count = 0;
  nlw_count = 0;
  tr_count = 0;
}

chr_flashgui_text::~chr_flashgui_text()
{
  fprintf(stdout, "flash access statistics:\n");
  fprintf(stdout, "%lld read\n", rd_count);
  fprintf(stdout, "%lld named_write\n", nw_count);
  fprintf(stdout, "%lld nameless_write\n", nlw_count);
  fprintf(stdout, "%lld trim\n", tr_count);
}

void chr_flashgui_text::set_trimmed(const chr_lsn lsn)
{
  fprintf(stdout, CHR_LSN_FORMAT " is trimmed\n", lsn);
  tr_count++;
}

void chr_flashgui_text::set_free(const chr_lsn lsn)
{
  fprintf(stdout, CHR_LSN_FORMAT " is free\n", lsn);
}

void chr_flashgui_text::set_used(const chr_lsn lsn)
{
  fprintf(stdout, CHR_LSN_FORMAT " is used\n", lsn);
}

void chr_flashgui_text::set_lastwrite(const chr_lsn lsn)
{
  fprintf(stdout, "last write is " CHR_LSN_FORMAT "\n", lsn);
}

void chr_flashgui_text::set_size(const chr_lsn lsn)
{
  fprintf(stdout, "flash size is " CHR_LSN_FORMAT "\n", lsn);
}

void chr_flashgui_text::set_nl_writing(const chr_lsn lsn)
{
  fprintf(stdout, CHR_LSN_FORMAT " is being namelessly written\n", lsn);
  nlw_count++;
}

void chr_flashgui_text::unset_nl_writing(const chr_lsn lsn)
{
  fprintf(stdout, CHR_LSN_FORMAT "'s nameless writing is done\n", lsn);
}

void chr_flashgui_text::set_writing(const chr_lsn lsn)
{
  fprintf(stdout, CHR_LSN_FORMAT " is being namely written\n", lsn);
  nw_count++;
}

void chr_flashgui_text::unset_writing(const chr_lsn lsn)
{
  fprintf(stdout, CHR_LSN_FORMAT "'s named writing is done\n", lsn);
}

void chr_flashgui_text::set_reading(const chr_lsn lsn)
{
  fprintf(stdout, CHR_LSN_FORMAT " is being read\n", lsn);
  rd_count++;
}

void chr_flashgui_text::unset_reading(const chr_lsn lsn)
{
  fprintf(stdout, CHR_LSN_FORMAT "'s reading is done\n", lsn);
}

